VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CString"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'  G.Beckmann   eMail: G.Beckmann@NikoCity.de

Option Explicit

'// API
Private Declare Function VarPtrArray& Lib "msvbvm60.dll" Alias "VarPtr" (ptr() As Any) ' VB5 -> msvbvm50.dll
Private Declare Sub RtlMoveMemory Lib "kernel32" (dst As Any, src As Any, ByVal nBytes&)
Private Declare Sub RtlZeroMemory Lib "kernel32" (dst As Any, ByVal nBytes&)

Private Type SAFEARRAYBOUND
    cElements       As Long
    lLbound         As Long
End Type

Private Type SAFEARRAY1D
    cDims           As Integer
    fFeatures       As Integer
    cbElements      As Long
    cLocks          As Long
    pvData          As Long
    Bounds(0 To 0)  As SAFEARRAYBOUND
End Type


'// Locales
Private m_aIntSrc%()
Private m_aIntDst%()
Private m_pArrSrc&
Private m_pArrDst&
Private m_saSrc     As SAFEARRAY1D
Private m_saDst     As SAFEARRAY1D
'


Private Sub Class_Initialize()
    m_saSrc.cbElements = 2
    m_saSrc.cDims = 1
    m_saSrc.Bounds(0).cElements = &H7FFFFFFF
    m_saDst = m_saSrc
    
    m_pArrSrc = VarPtrArray(m_aIntSrc)
    m_pArrDst = VarPtrArray(m_aIntDst)
        
    RtlMoveMemory ByVal m_pArrSrc, VarPtr(m_saSrc), 4
    RtlMoveMemory ByVal m_pArrDst, VarPtr(m_saDst), 4

End Sub

Private Sub Class_Terminate()
    RtlZeroMemory ByVal m_pArrSrc, 4
    RtlZeroMemory ByVal m_pArrDst, 4
End Sub


' rev. 1.1 09/14/2000
Friend Function Reverse(s As String) As String
    Dim iLen&, c&
    
    iLen = Len(s)
    Reverse = Space$(iLen)
    
    m_saSrc.pvData = StrPtr(s)
    m_saDst.pvData = StrPtr(Reverse)
    
    iLen = iLen - 1
    For c = 0 To iLen
        m_aIntDst(c) = m_aIntSrc(iLen - c)
    Next c
End Function


